//=============================================================================
// IncendiaryBall.
//=============================================================================
class IncendiaryBall extends BowenNade;

var ParticleGenerator smokeGen, fireGen;

simulated function SpawnSmokeEffects()
{
	Super.SpawnSmokeEffects();
	fireGen = Spawn(class'ParticleGenerator', Self);
	if (fireGen != None)
	{
		fireGen.particleTexture = FireTexture'Effects.Fire.Flame_J';
		fireGen.particleDrawScale = 0.5;
		fireGen.checkTime = 0.001;
		fireGen.riseRate = 0.0;
		fireGen.ejectSpeed = 10;
		fireGen.particleLifeSpan = 0.8;
		fireGen.bRandomEject = True;
		fireGen.SetBase(Self);
      fireGen.RemoteRole = ROLE_None;
	}
}

simulated function Destroyed()
{
	if (fireGen != None)
		fireGen.DelayedDestroy();
	Super.Destroyed();
}


defaultproperties
{
	ExplosionTime=0.3
	EffectsTime=1.0
	bBounce=False
	NumParticles=100
	ParticleClass=class'FireSprite'
	ParticleTexture=FireTexture'Effects.Fire.flame_b'
	AccurateRange=1000
	bExplodes=True
	blastRadius=300.000000
	DamageType=Flamed
	bIgnoresNanoDefense=True
	ParticleModifier=0.4
	ItemName="Incendiary cannon"
	ItemArticle="an"
	speed=3000.000000
	Damage=60.000000
	ExplosionDecal=Class'DeusEx.ScorchMark'
	DrawScale=0.800000
	Texture=FireTexture'Effects.Electricity.Nano_SFX_A'
	Skin=Texture'DeusExDeco.Skins.BarrelVirusTex1'
	MultiSkins(0)=Texture'DeusExDeco.Skins.BarrelVirusTex1'
	MultiSkins(1)=Texture'DeusExDeco.Skins.BarrelVirusTex1'
	MultiSkins(2)=Texture'DeusExDeco.Skins.BarrelVirusTex1'
	MultiSkins(3)=Texture'DeusExDeco.Skins.BarrelVirusTex1'
	MultiSkins(4)=Texture'DeusExDeco.Skins.BarrelVirusTex1'
	MultiSkins(5)=Texture'DeusExDeco.Skins.BarrelVirusTex1'
	MultiSkins(6)=Texture'DeusExDeco.Skins.BarrelVirusTex1'
	MultiSkins(7)=Texture'DeusExDeco.Skins.BarrelVirusTex1'
	Mesh=LodMesh'DeusExDeco.Tumbleweed'
	CollisionRadius=15.000000
	CollisionHeight=15.000000.
	AmbientSound=Sound'DeusExSounds.Weapons.WPApproach'
	ImpactSound=Sound'DeusExSounds.Generic.SmallExplosion2'
}
