//=============================================================================
// ProxDisc. 	(c) 2003 JimBowen
//=============================================================================
class ProxDisc extends ExplosiveDisc;

var(Bowen) float ProxRadius, SpawnPointCheckRadius;
var(Bowen) int MaxAreaDiscs, MaxTotalDiscs, mpMaxAreaDiscs, mpMaxTotalDiscs;
var bool bDoneMsg;

auto simulated state flying
{
	simulated function ProcessTouch(Actor Other, Vector HitLocation)
	{
		if (Other == Owner)
			return;
		if (Owner.IsA('DeusExPlayer') && Other.IsA('DeusExPlayer')) 
			if (TeamDMGame(DeusExPlayer(Owner).DXGame) != None)	
				if (DeusExPlayer(Other).PlayerReplicationInfo.Team == Team)
					return;
			
		DrawType = DT_None;
		bBlockActors = false;
		bBlockPlayers = false;
		BlowUpActor = Other;
		Detonate();
	}
	
	
	simulated function HitWall(vector HitNormal, actor Wall)
	{
		local proxdisc disc;
		local proxdisc FirstDisc;
		local PlayerStart Spawn;
		local SpawnExtension SpawnExt;
		local int i;
			
			
		SetCollisionSize(ProxRadius, ProxRadius);
		Super.HitWall(HitNormal, Wall);
		
		if (Level.NetMode == NM_Standalone)
			return;

			
			foreach RadiusActors (class 'PlayerStart', Spawn, SpawnPointCheckRadius)
			{
				if (FastTrace(Spawn.Location, Location) && !bDoneMsg)// only do this once, and if we can see the spawn
				{
					if (Owner.IsA('DeusExPlayer'))
					{
						DeusExPlayer(Owner).ClientMessage("Prox discs are not allowed in spawn rooms");
						log("ProxDisc placed in spawn room by " $ DeusExPlayer(Owner).PlayerReplicationInfo.PlayerName $ "!");
					}
					else log ("ProxDisc was found in spawn room with no player owner");
					SpawnSmoke();
					bDoneMsg = True;
					Destroy();
				}
			}

			foreach RadiusActors (class 'SpawnExtension', SpawnExt, SpawnPointCheckRadius)
			{
				if (FastTrace(SpawnExt.Location, Location) && !bDoneMsg)// only do this once, and if we can see the spawn
				{
					if (Owner.IsA('DeusExPlayer'))
					{
						DeusExPlayer(Owner).ClientMessage("Prox discs are not allowed in spawn rooms");
						log("ProxDisc placed in spawn room by " $ DeusExPlayer(Owner).PlayerReplicationInfo.PlayerName $ "!");
					}
					else log ("ProxDisc was found in spawn room with no player owner");
					SpawnSmoke();
					bDoneMsg = True;
					Destroy();
				}
			}
			
			bAlwaysRelevant=true;
	}
}

function Frob(Actor Frobber, Inventory frobWith)
{
}


defaultproperties
{
	 proxRadius=20.000000
	 SpawnPointCheckRadius=400.000000
	 mpBlastRadius=200.000000
	 GravMult=0.125000
	 Health=80
	 mpHealth=80
	 MaxAreaDiscs=64
	 MaxTotalDiscs=1024
	 mpMaxAreaDiscs=10
	 mpMaxTotalDiscs=60
	 mpDamage=130
	 bStickToWall=True
	 blastRadius=150.000000
	 DamageType=exploded
	 AccurateRange=0
	 maxRange=1000
	 bIgnoresNanoDefense=True
	 ItemName="proximity disc"
	 ItemArticle="a"
	 speed=1750.000000
	 MaxSpeed=3000.000000
	 ImpactSound=Sound'DeusExSounds.Generic.BulletHitFlesh'
	 LifeSpan=0.000000
	 Skin=Texture'Editor.Bkgnd'
	 MultiSkins(0)=Texture'DeusExUI.UserInterface.ConWindowActiveBackground'
	 MultiSkins(1)=Texture'DeusExDeco.Skins.AlarmLightTex7'
	 MultiSkins(2)=Texture'Editor.BkgndHi'
	 MultiSkins(3)=Texture'Editor.BkgndHi'
	 MultiSkins(4)=Texture'Editor.BkgndHi'
	 MultiSkins(5)=Texture'Editor.BkgndHi'
	 MultiSkins(6)=Texture'Editor.BkgndHi'
	 MultiSkins(7)=Texture'Editor.BkgndHi'
}
